using System;
using System.Runtime.Serialization;
using System.Web;

namespace wasDAVClient.Helpers
{
    public class wasDAVException : HttpException
    {
        public wasDAVException()
        {
        }

        public wasDAVException(string message) 
            : base(message)
        {}

        public wasDAVException(string message, int hr) 
            : base(message, hr)
        {}

        public wasDAVException(string message, Exception innerException) 
            : base(message, innerException)
        {}

        public wasDAVException(int httpCode, string message, Exception innerException) 
            : base(httpCode, message, innerException)
        {}

        public wasDAVException(int httpCode, string message) 
            : base(httpCode, message)
        {}

        public wasDAVException(int httpCode, string message, int hr) 
            : base(httpCode, message, hr)
        {}

        protected wasDAVException(SerializationInfo info, StreamingContext context) 
            : base(info, context)
        {}

        public override string ToString()
        {
            var s = string.Format("HttpStatusCode: {0}", base.GetHttpCode());
            s += Environment.NewLine + string.Format("ErrorCode: {0}", ErrorCode);
            s += Environment.NewLine + string.Format("Message: {0}", Message);
            s += Environment.NewLine + base.ToString();

            return s;
        }
    }
}